diff --git a/xlators/mgmt/glusterd/src/glusterd-handler.c b/xlators/mgmt/glusterd/src/glusterd-handler.c
index bdc56da8db6..187f3cc4c25 100644
--- a/xlators/mgmt/glusterd/src/glusterd-handler.c
+++ b/xlators/mgmt/glusterd/src/glusterd-handler.c
@@ -2827,7 +2827,7 @@ __glusterd_handle_friend_update(rpcsvc_request_t *req)
              * friend.  The friend state machine will take care of
              * correcting the state as required
              */
-            peerinfo->state.state = GD_FRIEND_STATE_BEFRIENDED;
+            peerinfo->state = GD_FRIEND_STATE_BEFRIENDED;
 
             ret = glusterd_friend_add_from_peerinfo(peerinfo, 0, &args);
         } else {
@@ -3688,7 +3688,7 @@ glusterd_probe_begin(rpcsvc_request_t *req, const char *hoststr, int port,
         }
 
     } else if (peerinfo->connected &&
-               (GD_FRIEND_STATE_BEFRIENDED == peerinfo->state.state)) {
+               (GD_FRIEND_STATE_BEFRIENDED == peerinfo->state)) {
         if (peerinfo->detaching) {
             ret = -1;
             if (op_errno)
@@ -5611,7 +5611,7 @@ glusterd_get_state(rpcsvc_request_t *req, dict_t *dict)
                 peerinfo->hostname);
         fprintf(fp, "Peer%d.uuid: %s\n", count, gd_peer_uuid_str(peerinfo));
         fprintf(fp, "Peer%d.state: %s\n", count,
-                glusterd_friend_sm_state_name_get(peerinfo->state.state));
+                glusterd_friend_sm_state_name_get(peerinfo->state));
         fprintf(fp, "Peer%d.connected: %s\n", count,
                 peerinfo->connected ? "Connected" : "Disconnected");
 
@@ -6328,10 +6328,10 @@ __glusterd_peer_rpc_notify(struct rpc_clnt *rpc, void *mydata,
                    "Peer <%s> (<%s>), in state <%s>, has disconnected "
                    "from glusterd.",
                    peerinfo->hostname, uuid_utoa(peerinfo->uuid),
-                   glusterd_friend_sm_state_name_get(peerinfo->state.state));
+                   glusterd_friend_sm_state_name_get(peerinfo->state));
             gf_event(EVENT_PEER_DISCONNECT, "peer=%s;uuid=%s;state=%s",
                      peerinfo->hostname, uuid_utoa(peerinfo->uuid),
-                     glusterd_friend_sm_state_name_get(peerinfo->state.state));
+                     glusterd_friend_sm_state_name_get(peerinfo->state));
 
             if (peerinfo->connected) {
                 if (conf->op_version < GD_OP_VERSION_3_6_0) {
@@ -6358,7 +6358,7 @@ __glusterd_peer_rpc_notify(struct rpc_clnt *rpc, void *mydata,
             }
 
             if ((peerinfo->quorum_contrib != QUORUM_DOWN) &&
-                (peerinfo->state.state == GD_FRIEND_STATE_BEFRIENDED)) {
+                (peerinfo->state == GD_FRIEND_STATE_BEFRIENDED)) {
                 peerinfo->quorum_contrib = QUORUM_DOWN;
                 quorum_action = _gf_true;
                 peerinfo->quorum_action = _gf_false;
@@ -6367,7 +6367,7 @@ __glusterd_peer_rpc_notify(struct rpc_clnt *rpc, void *mydata,
             /* Remove peer if it is not a friend and connection/handshake
              *  fails, and notify cli. Happens only during probe.
              */
-            if (peerinfo->state.state == GD_FRIEND_STATE_DEFAULT) {
+            if (peerinfo->state == GD_FRIEND_STATE_DEFAULT) {
                 glusterd_friend_remove_notify(peerctx, op_errno);
                 goto out;
             }
diff --git a/xlators/mgmt/glusterd/src/glusterd-mgmt.c b/xlators/mgmt/glusterd/src/glusterd-mgmt.c
index d596827ab5d..1e36695a508 100644
--- a/xlators/mgmt/glusterd/src/glusterd-mgmt.c
+++ b/xlators/mgmt/glusterd/src/glusterd-mgmt.c
@@ -715,7 +715,7 @@ glusterd_mgmt_v3_initiate_lockdown(glusterd_op_t op, dict_t *dict,
         if (!peerinfo->connected)
             continue;
         if (op != GD_OP_SYNC_VOLUME &&
-            peerinfo->state.state != GD_FRIEND_STATE_BEFRIENDED)
+            peerinfo->state != GD_FRIEND_STATE_BEFRIENDED)
             continue;
 
         gd_mgmt_v3_lock(op, dict, peerinfo, &args, MY_UUID, peer_uuid);
@@ -1063,7 +1063,7 @@ glusterd_mgmt_v3_pre_validate(glusterd_op_t op, dict_t *req_dict,
         if (!peerinfo->connected)
             continue;
         if (op != GD_OP_SYNC_VOLUME &&
-            peerinfo->state.state != GD_FRIEND_STATE_BEFRIENDED)
+            peerinfo->state != GD_FRIEND_STATE_BEFRIENDED)
             continue;
 
         gd_mgmt_v3_pre_validate_req(op, req_dict, peerinfo, &args, MY_UUID,
@@ -1408,7 +1408,7 @@ glusterd_mgmt_v3_brick_op(glusterd_op_t op, dict_t *op_ctx, dict_t *req_dict,
         if (!peerinfo->connected)
             continue;
         if (op != GD_OP_SYNC_VOLUME &&
-            peerinfo->state.state != GD_FRIEND_STATE_BEFRIENDED)
+            peerinfo->state != GD_FRIEND_STATE_BEFRIENDED)
             continue;
 
         gd_mgmt_v3_brick_op_req(op, req_dict, peerinfo, &args, MY_UUID,
@@ -1686,7 +1686,7 @@ glusterd_mgmt_v3_commit(glusterd_op_t op, dict_t *op_ctx, dict_t *req_dict,
             continue;
 
         if (op != GD_OP_SYNC_VOLUME &&
-            peerinfo->state.state != GD_FRIEND_STATE_BEFRIENDED)
+            peerinfo->state != GD_FRIEND_STATE_BEFRIENDED)
             continue;
 
         gd_mgmt_v3_commit_req(op, req_dict, peerinfo, &args, MY_UUID,
@@ -1948,7 +1948,7 @@ glusterd_mgmt_v3_post_commit(glusterd_op_t op, dict_t *op_ctx, dict_t *req_dict,
             continue;
 
         if (op != GD_OP_SYNC_VOLUME &&
-            peerinfo->state.state != GD_FRIEND_STATE_BEFRIENDED)
+            peerinfo->state != GD_FRIEND_STATE_BEFRIENDED)
             continue;
 
         gd_mgmt_v3_post_commit_req(op, req_dict, peerinfo, &args, MY_UUID,
@@ -2170,7 +2170,7 @@ glusterd_mgmt_v3_post_validate(glusterd_op_t op, int32_t op_ret, dict_t *dict,
         if (!peerinfo->connected)
             continue;
         if (op != GD_OP_SYNC_VOLUME &&
-            peerinfo->state.state != GD_FRIEND_STATE_BEFRIENDED)
+            peerinfo->state != GD_FRIEND_STATE_BEFRIENDED)
             continue;
 
         gd_mgmt_v3_post_validate_req(op, op_ret, req_dict, peerinfo, &args,
@@ -2353,7 +2353,7 @@ glusterd_mgmt_v3_release_peer_locks(glusterd_op_t op, dict_t *dict,
         if (!peerinfo->connected)
             continue;
         if (op != GD_OP_SYNC_VOLUME &&
-            peerinfo->state.state != GD_FRIEND_STATE_BEFRIENDED)
+            peerinfo->state != GD_FRIEND_STATE_BEFRIENDED)
             continue;
 
         gd_mgmt_v3_unlock(op, dict, peerinfo, &args, MY_UUID, peer_uuid);
diff --git a/xlators/mgmt/glusterd/src/glusterd-op-sm.c b/xlators/mgmt/glusterd/src/glusterd-op-sm.c
index b546dbf7807..2e363083958 100644
--- a/xlators/mgmt/glusterd/src/glusterd-op-sm.c
+++ b/xlators/mgmt/glusterd/src/glusterd-op-sm.c
@@ -3826,7 +3826,7 @@ glusterd_op_ac_send_lock(glusterd_op_sm_event_t *event, void *ctx)
 
         if (!peerinfo->connected || !peerinfo->mgmt)
             continue;
-        if ((peerinfo->state.state != GD_FRIEND_STATE_BEFRIENDED) &&
+        if ((peerinfo->state != GD_FRIEND_STATE_BEFRIENDED) &&
             (glusterd_op_get_op() != GD_OP_SYNC_VOLUME))
             continue;
 
@@ -3928,7 +3928,7 @@ glusterd_op_ac_send_unlock(glusterd_op_sm_event_t *event, void *ctx)
 
         if (!peerinfo->connected || !peerinfo->mgmt || !peerinfo->locked)
             continue;
-        if ((peerinfo->state.state != GD_FRIEND_STATE_BEFRIENDED) &&
+        if ((peerinfo->state != GD_FRIEND_STATE_BEFRIENDED) &&
             (glusterd_op_get_op() != GD_OP_SYNC_VOLUME))
             continue;
         /* Based on the op_version,
@@ -4541,7 +4541,7 @@ glusterd_op_ac_send_stage_op(glusterd_op_sm_event_t *event, void *ctx)
 
         if (!peerinfo->connected || !peerinfo->mgmt)
             continue;
-        if ((peerinfo->state.state != GD_FRIEND_STATE_BEFRIENDED) &&
+        if ((peerinfo->state != GD_FRIEND_STATE_BEFRIENDED) &&
             (glusterd_op_get_op() != GD_OP_SYNC_VOLUME))
             continue;
 
@@ -5158,7 +5158,7 @@ glusterd_op_ac_send_commit_op(glusterd_op_sm_event_t *event, void *ctx)
 
         if (!peerinfo->connected || !peerinfo->mgmt)
             continue;
-        if ((peerinfo->state.state != GD_FRIEND_STATE_BEFRIENDED) &&
+        if ((peerinfo->state != GD_FRIEND_STATE_BEFRIENDED) &&
             (glusterd_op_get_op() != GD_OP_SYNC_VOLUME))
             continue;
 
diff --git a/xlators/mgmt/glusterd/src/glusterd-peer-utils.c b/xlators/mgmt/glusterd/src/glusterd-peer-utils.c
index 7c486069240..bfa5488a496 100644
--- a/xlators/mgmt/glusterd/src/glusterd-peer-utils.c
+++ b/xlators/mgmt/glusterd/src/glusterd-peer-utils.c
@@ -112,7 +112,7 @@ gd_peerinfo_find_from_hostname(const char *hoststr)
         {
             if (!strncasecmp(tmphost->hostname, hoststr, 1024)) {
                 gf_msg_debug(this->name, 0, "Friend %s found.. state: %d",
-                             tmphost->hostname, peer->state.state);
+                             tmphost->hostname, peer->state);
                 found = peer; /* Probably needs to be
                                  dereferenced*/
                 goto unlock;
@@ -282,7 +282,7 @@ glusterd_peerinfo_find_by_uuid(uuid_t uuid)
     {
         if (!gf_uuid_compare(entry->uuid, uuid)) {
             found = entry; /* Probably should be rcu_dereferenced */
-            state = found->state.state;
+            state = found->state;
             break;
         }
     }
@@ -359,7 +359,7 @@ glusterd_peerinfo_new(glusterd_friend_sm_state_t state, uuid_t *uuid,
 
     CDS_INIT_LIST_HEAD(&new_peer->uuid_list);
 
-    new_peer->state.state = state;
+    new_peer->state = state;
 
     CDS_INIT_LIST_HEAD(&new_peer->hostnames);
     if (hostname) {
@@ -383,7 +383,7 @@ glusterd_peerinfo_new(glusterd_friend_sm_state_t state, uuid_t *uuid,
     if (ret)
         goto out;
 
-    if (new_peer->state.state == GD_FRIEND_STATE_BEFRIENDED)
+    if (new_peer->state == GD_FRIEND_STATE_BEFRIENDED)
         new_peer->quorum_contrib = QUORUM_WAITING;
     new_peer->port = port;
 
@@ -418,7 +418,7 @@ glusterd_chk_peers_connected_befriended(uuid_t skip_uuid)
             !gf_uuid_compare(skip_uuid, peerinfo->uuid))
             continue;
 
-        if ((GD_FRIEND_STATE_BEFRIENDED != peerinfo->state.state) ||
+        if ((GD_FRIEND_STATE_BEFRIENDED != peerinfo->state) ||
             !(peerinfo->connected)) {
             ret = _gf_false;
             break;
@@ -523,7 +523,7 @@ glusterd_are_vol_all_peers_up(glusterd_volinfo_t *volinfo,
             /*Found peer who owns the brick, return false
              * if peer is not connected or not friend */
             if (!(peerinfo->connected) ||
-                (peerinfo->state.state != GD_FRIEND_STATE_BEFRIENDED)) {
+                (peerinfo->state != GD_FRIEND_STATE_BEFRIENDED)) {
                 *down_peerstr = gf_strdup(peerinfo->hostname);
                 RCU_READ_UNLOCK;
                 gf_msg_debug(THIS->name, 0, "Peer %s is down. ", *down_peerstr);
@@ -932,7 +932,7 @@ gd_add_peer_detail_to_dict(glusterd_peerinfo_t *peerinfo, dict_t *friends,
     }
 
     keylen = snprintf(key, sizeof(key), "friend%d.stateId", count);
-    ret = dict_set_int32n(friends, key, keylen, peerinfo->state.state);
+    ret = dict_set_int32n(friends, key, keylen, peerinfo->state);
     if (ret) {
         gf_smsg(this->name, GF_LOG_ERROR, 0, GD_MSG_DICT_SET_FAILED,
                 "Key=%s in dict", key, NULL);
@@ -942,7 +942,7 @@ gd_add_peer_detail_to_dict(glusterd_peerinfo_t *peerinfo, dict_t *friends,
     keylen = snprintf(key, sizeof(key), "friend%d.state", count);
     ret = dict_set_strn(
         friends, key, keylen,
-        glusterd_friend_sm_state_name_get(peerinfo->state.state));
+        glusterd_friend_sm_state_name_get(peerinfo->state));
     if (ret) {
         gf_smsg(this->name, GF_LOG_ERROR, 0, GD_MSG_DICT_SET_FAILED, "key=%s",
                 key, NULL);
@@ -986,7 +986,7 @@ glusterd_peerinfo_find_by_generation(uint32_t generation)
     {
         if (entry->generation == generation) {
             found = entry; /* Probably should be rcu_dereferenced */
-            state = found->state.state;
+            state = found->state;
             break;
         }
     }
diff --git a/xlators/mgmt/glusterd/src/glusterd-replace-brick.c b/xlators/mgmt/glusterd/src/glusterd-replace-brick.c
index 509224a1271..93239c6b539 100644
--- a/xlators/mgmt/glusterd/src/glusterd-replace-brick.c
+++ b/xlators/mgmt/glusterd/src/glusterd-replace-brick.c
@@ -296,7 +296,7 @@ glusterd_op_stage_replace_brick(dict_t *dict, char **op_errstr,
             *op_errstr = gf_strdup(msg);
             goto out;
 
-        } else if (GD_FRIEND_STATE_BEFRIENDED != peerinfo->state.state) {
+        } else if (GD_FRIEND_STATE_BEFRIENDED != peerinfo->state) {
             RCU_READ_UNLOCK;
             ret = -1;
             snprintf(msg, sizeof(msg),
diff --git a/xlators/mgmt/glusterd/src/glusterd-reset-brick.c b/xlators/mgmt/glusterd/src/glusterd-reset-brick.c
index 67af4ad4bc6..4b57dc242c1 100644
--- a/xlators/mgmt/glusterd/src/glusterd-reset-brick.c
+++ b/xlators/mgmt/glusterd/src/glusterd-reset-brick.c
@@ -170,7 +170,7 @@ glusterd_reset_brick_prevalidate(dict_t *dict, char **op_errstr,
             *op_errstr = gf_strdup(msg);
             goto out;
 
-        } else if (GD_FRIEND_STATE_BEFRIENDED != peerinfo->state.state) {
+        } else if (GD_FRIEND_STATE_BEFRIENDED != peerinfo->state) {
             RCU_READ_UNLOCK;
             ret = -1;
             snprintf(msg, sizeof(msg),
diff --git a/xlators/mgmt/glusterd/src/glusterd-sm.c b/xlators/mgmt/glusterd/src/glusterd-sm.c
index 36c91b6ae35..8eab5e32535 100644
--- a/xlators/mgmt/glusterd/src/glusterd-sm.c
+++ b/xlators/mgmt/glusterd/src/glusterd-sm.c
@@ -537,7 +537,7 @@ glusterd_should_update_peer(glusterd_peerinfo_t *peerinfo,
                             glusterd_peerinfo_t *cur_peerinfo)
 {
     if ((peerinfo == cur_peerinfo) ||
-        (peerinfo->state.state == GD_FRIEND_STATE_BEFRIENDED))
+        (peerinfo->state == GD_FRIEND_STATE_BEFRIENDED))
         return _gf_true;
 
     return _gf_false;
@@ -1104,10 +1104,10 @@ glusterd_friend_sm_transition_state(uuid_t peerid, char *peername,
     }
 
     (void)glusterd_sm_tr_log_transition_add(
-        &peerinfo->sm_log, peerinfo->state.state, state[event_type].next_state,
+        &peerinfo->sm_log, peerinfo->state, state[event_type].next_state,
         event_type);
 
-    uatomic_set(&peerinfo->state.state, state[event_type].next_state);
+    uatomic_set(&peerinfo->state, state[event_type].next_state);
 
     ret = 0;
 out:
@@ -1428,7 +1428,7 @@ gd_does_peer_affect_quorum(glusterd_friend_sm_state_t old_state,
         (event_type != GD_FRIEND_EVENT_RCVD_ACC) &&
         (event_type != GD_FRIEND_EVENT_LOCAL_ACC))
         goto out;
-    if ((peerinfo->state.state == GD_FRIEND_STATE_BEFRIENDED) &&
+    if ((peerinfo->state == GD_FRIEND_STATE_BEFRIENDED) &&
         peerinfo->connected) {
         affects = _gf_true;
     }
@@ -1474,7 +1474,7 @@ glusterd_friend_sm()
                 GF_FREE(event);
                 continue;
             }
-            old_state = peerinfo->state.state;
+            old_state = peerinfo->state;
             RCU_READ_UNLOCK;
             gf_msg_debug("glusterd", 0, "Dequeued event of type: '%s'",
                          glusterd_friend_sm_event_name_get(event_type));
diff --git a/xlators/mgmt/glusterd/src/glusterd-sm.h b/xlators/mgmt/glusterd/src/glusterd-sm.h
index cca9e459d7c..a4e3af4c96e 100644
--- a/xlators/mgmt/glusterd/src/glusterd-sm.h
+++ b/xlators/mgmt/glusterd/src/glusterd-sm.h
@@ -43,11 +43,6 @@ typedef enum glusterd_friend_sm_state_ {
     GD_FRIEND_STATE_MAX
 } glusterd_friend_sm_state_t;
 
-typedef struct glusterd_peer_state_info_ {
-    glusterd_friend_sm_state_t state;
-    struct timeval transition_time;
-} glusterd_peer_state_info_t;
-
 typedef struct glusterd_peer_hostname_ {
     char *hostname;
     struct cds_list_head hostname_list;
@@ -74,7 +69,7 @@ struct glusterd_peerinfo_ {
     char uuid_str[50]; /* Retrieve this using
                         * gd_peer_uuid_str ()
                         */
-    glusterd_peer_state_info_t state;
+    glusterd_friend_sm_state_t state;
     char *hostname;
     struct cds_list_head hostnames;
     int port;
diff --git a/xlators/mgmt/glusterd/src/glusterd-snapshot.c b/xlators/mgmt/glusterd/src/glusterd-snapshot.c
index 68174285b9f..70bf4cfa78a 100644
--- a/xlators/mgmt/glusterd/src/glusterd-snapshot.c
+++ b/xlators/mgmt/glusterd/src/glusterd-snapshot.c
@@ -120,7 +120,7 @@ glusterd_find_missed_snap(dict_t *rsp_dict, glusterd_volinfo_t *vol,
              * if peer is not connected or not   *
              * friend add it to missed snap list */
             if (!(peerinfo->connected) ||
-                (peerinfo->state.state != GD_FRIEND_STATE_BEFRIENDED)) {
+                (peerinfo->state != GD_FRIEND_STATE_BEFRIENDED)) {
                 ret = glusterd_add_missed_snaps_to_dict(
                     rsp_dict, vol, brickinfo, brick_count + 1, op);
                 if (ret) {
diff --git a/xlators/mgmt/glusterd/src/glusterd-statedump.c b/xlators/mgmt/glusterd/src/glusterd-statedump.c
index c1367d04e6b..fd6d6ffab76 100644
--- a/xlators/mgmt/glusterd/src/glusterd-statedump.c
+++ b/xlators/mgmt/glusterd/src/glusterd-statedump.c
@@ -36,7 +36,7 @@ glusterd_dump_peer(glusterd_peerinfo_t *peerinfo, char *input_key, int index,
     gf_proc_dump_write(key, "%d", peerinfo->port);
 
     gf_proc_dump_build_key(key, subkey, "state");
-    gf_proc_dump_write(key, "%d", peerinfo->state.state);
+    gf_proc_dump_write(key, "%d", peerinfo->state);
 
     gf_proc_dump_build_key(key, subkey, "quorum-action");
     gf_proc_dump_write(key, "%d", peerinfo->quorum_action);
diff --git a/xlators/mgmt/glusterd/src/glusterd-store.c b/xlators/mgmt/glusterd/src/glusterd-store.c
index 091bb4ee526..6f72bd72cff 100644
--- a/xlators/mgmt/glusterd/src/glusterd-store.c
+++ b/xlators/mgmt/glusterd/src/glusterd-store.c
@@ -4445,7 +4445,7 @@ glusterd_store_peer_write(int fd, glusterd_peerinfo_t *peerinfo)
 
     ret = snprintf(buf + total_len, sizeof(buf) - total_len, "%s=%s\n%s=%d\n",
                    GLUSTERD_STORE_KEY_PEER_UUID, uuid_utoa(peerinfo->uuid),
-                   GLUSTERD_STORE_KEY_PEER_STATE, peerinfo->state.state);
+                   GLUSTERD_STORE_KEY_PEER_STATE, peerinfo->state);
     if (ret < 0 || ret >= sizeof(buf) - total_len) {
         ret = -1;
         goto out;
@@ -4611,7 +4611,7 @@ glusterd_store_retrieve_peers(xlator_t *this)
                     gf_uuid_parse(value, peerinfo->uuid);
             } else if (!strncmp(GLUSTERD_STORE_KEY_PEER_STATE, key,
                                 SLEN(GLUSTERD_STORE_KEY_PEER_STATE))) {
-                peerinfo->state.state = atoi(value);
+                peerinfo->state = atoi(value);
             } else if (!strncmp(GLUSTERD_STORE_KEY_PEER_HOSTNAME, key,
                                 SLEN(GLUSTERD_STORE_KEY_PEER_HOSTNAME))) {
                 ret = gd_add_address_to_peer(peerinfo, value, _gf_false);
diff --git a/xlators/mgmt/glusterd/src/glusterd-syncop.c b/xlators/mgmt/glusterd/src/glusterd-syncop.c
index 700a7092e8d..b010a1182c7 100644
--- a/xlators/mgmt/glusterd/src/glusterd-syncop.c
+++ b/xlators/mgmt/glusterd/src/glusterd-syncop.c
@@ -1219,7 +1219,7 @@ gd_lock_op_phase(glusterd_conf_t *conf, glusterd_op_t op, dict_t *op_ctx,
         if (!peerinfo->connected)
             continue;
         if (op != GD_OP_SYNC_VOLUME &&
-            peerinfo->state.state != GD_FRIEND_STATE_BEFRIENDED)
+            peerinfo->state != GD_FRIEND_STATE_BEFRIENDED)
             continue;
 
         if (cluster_lock) {
@@ -1351,7 +1351,7 @@ gd_stage_op_phase(glusterd_op_t op, dict_t *op_ctx, dict_t *req_dict,
         if (!peerinfo->connected)
             continue;
         if (op != GD_OP_SYNC_VOLUME &&
-            peerinfo->state.state != GD_FRIEND_STATE_BEFRIENDED)
+            peerinfo->state != GD_FRIEND_STATE_BEFRIENDED)
             continue;
 
         (void)gd_syncop_mgmt_stage_op(peerinfo, &args, MY_UUID, tmp_uuid, op,
@@ -1499,7 +1499,7 @@ gd_commit_op_phase(glusterd_op_t op, dict_t *op_ctx, dict_t *req_dict,
         if (!peerinfo->connected)
             continue;
         if (op != GD_OP_SYNC_VOLUME &&
-            peerinfo->state.state != GD_FRIEND_STATE_BEFRIENDED)
+            peerinfo->state != GD_FRIEND_STATE_BEFRIENDED)
             continue;
 
         (void)gd_syncop_mgmt_commit_op(peerinfo, &args, MY_UUID, tmp_uuid, op,
@@ -1579,7 +1579,7 @@ gd_unlock_op_phase(glusterd_conf_t *conf, glusterd_op_t op, int *op_ret,
             if (!peerinfo->connected)
                 continue;
             if (op != GD_OP_SYNC_VOLUME &&
-                peerinfo->state.state != GD_FRIEND_STATE_BEFRIENDED)
+                peerinfo->state != GD_FRIEND_STATE_BEFRIENDED)
                 continue;
 
             /* Only unlock peers that were locked */
@@ -1608,7 +1608,7 @@ gd_unlock_op_phase(glusterd_conf_t *conf, glusterd_op_t op, int *op_ret,
                 if (!peerinfo->connected)
                     continue;
                 if (op != GD_OP_SYNC_VOLUME &&
-                    peerinfo->state.state != GD_FRIEND_STATE_BEFRIENDED)
+                    peerinfo->state != GD_FRIEND_STATE_BEFRIENDED)
                     continue;
 
                 gd_syncop_mgmt_v3_unlock(op_ctx, peerinfo, &args, MY_UUID,
diff --git a/xlators/mgmt/glusterd/src/glusterd-utils.c b/xlators/mgmt/glusterd/src/glusterd-utils.c
index 967d3266439..ab6bdd68bf7 100644
--- a/xlators/mgmt/glusterd/src/glusterd-utils.c
+++ b/xlators/mgmt/glusterd/src/glusterd-utils.c
@@ -8177,7 +8177,7 @@ glusterd_new_brick_validate(char *brick, glusterd_brickinfo_t *brickinfo,
             goto out;
         }
 
-        if (peerinfo->state.state != GD_FRIEND_STATE_BEFRIENDED) {
+        if (peerinfo->state != GD_FRIEND_STATE_BEFRIENDED) {
             snprintf(op_errstr, len,
                      "Host %s is not in \'Peer "
                      "in Cluster\' state",
@@ -14042,7 +14042,7 @@ glusterd_count_connected_peers(int32_t *count)
     {
         /* Find peer who is connected and is a friend */
         if ((peerinfo->connected) &&
-            (peerinfo->state.state == GD_FRIEND_STATE_BEFRIENDED)) {
+            (peerinfo->state == GD_FRIEND_STATE_BEFRIENDED)) {
             (*count)++;
         }
     }
